/*
 * Copyright (C) 2016 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.thema.lucsim.gui;

import java.awt.Color;
import java.awt.Component;
import org.thema.lucsim.engine.StateLayer;
import org.thema.lucsim.engine.NumLayer;
import org.thema.lucsim.engine.Project;
import org.thema.lucsim.engine.Simulation;
import java.awt.geom.Point2D;
import javax.swing.DefaultListCellRenderer;
import javax.swing.DefaultListModel;
import javax.swing.JList;

/**
 * Ouvre un jpanel contenant la liste des des etat de chaque couche pour un
 * point donné
 *
 * @author alexis
 */
public class PanelPoint extends javax.swing.JPanel {

    /**
     * liste model
     */
    private DefaultListModel dlm;

    /**
     * Constructeur
     */
    public PanelPoint(Simulation simulation, Point2D position)  {

        initComponents();
        Project project = simulation.getProject();
        dlm = new DefaultListModel();

        /*coordonnée point*/
        String s = String.format("X : %g  Y : %g", position.getX(), position.getY());
        dlm.addElement(s);
        
        for(StateLayer l : project.getStateLayers()) {
            double ind = l.getElement(position);
            if(Double.isNaN(ind)) {
                dlm.addElement(l.getName() +  " : (outside)");
            } else {
                dlm.addElement(l.getName()+ " : " + project.getStates().getState((int)ind).getName());
            }
        }
        
        for(NumLayer l : project.getNumLayers()) {
            dlm.addElement(l.getName() + " : " + l.getElement(position));
        }
 
        //Creation liste a partir da la dlm
        jList.setModel(dlm);
        jList.setCellRenderer(new DefaultListCellRenderer() {
            @Override
            public Component getListCellRendererComponent(JList<?> list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
                Component comp = super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus); 
                if(index == 0) {
                    setBackground(Color.LIGHT_GRAY);
                    setForeground(new Color(47, 129, 157));
                }
                return comp;
            }
            
        });
    }


    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane2 = new javax.swing.JScrollPane();
        jList = new javax.swing.JList();

        setPreferredSize(new java.awt.Dimension(315, 132));

        jScrollPane2.setViewportView(jList);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 274, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 146, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JList jList;
    private javax.swing.JScrollPane jScrollPane2;
    // End of variables declaration//GEN-END:variables

}
